﻿if not IsAddOnLoaded("PallyPower") then return end

--[[
	Tukui PallyPower Skinner
	
	All credits of this skin script is by SkinPallyPower and his author MrRuben5.
	
	Addon change by Hanomi for work in ThunderUI and add size options
--]]

----------------------------------------------
-- Skinner configuration
----------------------------------------------	

local font, fontsize = TheThunderUI.fonts[TheThunderUI.db.font], 8 -- font and font size
local SkinPPHeight = fixscale(28) -- New PallyPower Height -- default 34
local SkinPPWidth = fixscale(80) -- New PallyPower Width -- default 100

----------------------------------------------
-- Othder default options. plz not edit it!
----------------------------------------------	

local _G = _G
local _, frame, tex

local ppmscale = fixscale(1) -- fix pallypower scale, if change it make ugly borders :E

PALLYPOWER_DEFAULT_VALUES.cBuffNeedAll     = {r = 0.6, g = 0.2, b = 0.2, t = 1}
PALLYPOWER_DEFAULT_VALUES.cBuffNeedSome    = {r = 0.15, g = 0.15, b = 0.15, t = 1}
PALLYPOWER_DEFAULT_VALUES.cBuffNeedSpecial = {r = 0, g = 6/16, b = 9/16, t = 1}
PALLYPOWER_DEFAULT_VALUES.cBuffGood        = {r = TheThunderUI.db.RGB4, g = TheThunderUI.db.RGB5, b = TheThunderUI.db.RGB6, t = 1}

PALLYPOWER_DEFAULT_VALUES.display.buttonHeight = SkinPPHeight
PALLYPOWER_DEFAULT_VALUES.display.buttonWidth = SkinPPWidth

PallyPower.opt.cBuffNeedAll     = {r = 0.6, g = 0.2, b = 0.2, t = 1}
PallyPower.opt.cBuffNeedSome    = {r = 0.15, g = 0.15, b = 0.15, t = 1}
PallyPower.opt.cBuffNeedSpecial = {r = 0, g = 6/16, b = 9/16, t = 1}
PallyPower.opt.cBuffGood        = {r = TheThunderUI.db.RGB4, g = TheThunderUI.db.RGB5, b = TheThunderUI.db.RGB6, t = 1}

PallyPower.opt.buffscale = ppmscale
--PallyPower.opt.configscale = 0.8
PallyPower.opt.display.gapping = fixscale(4)

PallyPowerAnchor:SetFrameStrata("MEDIUM")
PallyPowerAnchor:SetScale(0.75)
PallyPower.opt.display.buttonHeight = SkinPPHeight
PallyPower.opt.display.buttonWidth = SkinPPWidth

----------------------------------------------
-- Begin!
----------------------------------------------

local _applyskin = PallyPower.ApplySkin
function PallyPower:ApplySkin(skinname)

	local needSkinning = {PallyPowerAuto, PallyPowerRF, PallyPowerAura}

	for i = 1, PALLYPOWER_MAXCLASSES do
		table.insert(needSkinning, PallyPower.classButtons[i])
		for j = 1, PALLYPOWER_MAXPERCLASS do
			table.insert(needSkinning, PallyPower.playerButtons[i][j])
		end
	end
		
	for _,frame in pairs(needSkinning) do
		frame:SetBackdrop({
			bgFile = TheThunderUI.textures[TheThunderUI.db.blanktext],
			insets = { left = fixscale(2), right = fixscale(2), top = fixscale(2), bottom = fixscale(2) }
		})
		frame:SetHeight(SkinPPHeight)
		frame:SetWidth(SkinPPWidth)
		if not frame.bg then
			frame.bg = CreateFrame('Frame', nil, frame)
			frame.bg:SetAllPoints(frame)
			frame.bg:SetFrameLevel(frame:GetFrameLevel()-1)
			SetTemplate(frame.bg)
		end
		
		local fname = frame:GetName()
		--print(fname)
		for _, fontstring in pairs({"Time", "Time2", "Text", "Player1", "Player2", "Rng", "Dead", "Name"}) do
			local fs = _G[fname..fontstring]
			if fs then
				fs:SetFont(font, fontsize, 'THINOUTLINE')
				fs:SetShadowColor(0,0,0,0)
				fs:SetWidth(999)
				if not fname:find("PowerC%d+P%d+$") then
					if fontstring == "Text" then
						fs:ClearAllPoints()
						fs:SetJustifyH("LEFT")
						fs:SetPoint("LEFT",fname:find("Auto$") and (SkinPPHeight-fixscale(2)) or (SkinPPHeight*2), 0)
					elseif fontstring == "Time" then 
						fs:ClearAllPoints()
						fs:SetJustifyH("RIGHT")
						fs:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, 0)
					elseif fontstring == "Time2" then
						fs:ClearAllPoints()
						fs:SetJustifyH("RIGHT")
						fs:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 0, 0)
					end
				else
					if fontstring == "Name" then
						fs:ClearAllPoints()
						fs:SetJustifyH("RIGHT")
						fs:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 0, 0)
					elseif fontstring == "Time" then 
						fs:ClearAllPoints()
						fs:SetJustifyH("LEFT")
						fs:SetPoint("TOPLEFT", frame, "TOPLEFT", SkinPPHeight, 0)
					elseif fontstring == "Rng" then 
						fs:ClearAllPoints()
						fs:SetJustifyH("RIGHT")
						fs:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, 0)
					end
				--	if fontstring == "Text" then
				--		fs:ClearAllPoints()
				--		fs:SetJustifyH("LEFT")
				--		fs:SetWidth(999)
				--		fs:SetPoint("LEFT",fname:find("Auto$") and (SkinPPHeight-fixscale(2)) or (SkinPPHeight*2), 0)
				--	elseif fontstring == "Time" then 
				--		fs:ClearAllPoints()
				--		fs:SetWidth(999)
				--		fs:SetJustifyH("RIGHT")
				--		fs:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, 0)
				--	else
				--		fs:ClearAllPoints()
				--		fs:SetWidth(999)
				--		fs:SetJustifyH("RIGHT")
				--		fs:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 0, 0)
				--	end
				end
			end
		end
		for _, tex in pairs({"Icon", "ClassIcon", "BuffIcon", "IconSeal"}) do
			if _G[fname..tex] and not _G[fname..'New'..tex] then
				local oldicon = _G[fname..tex]
				oldicon:SetAlpha(0)
				oldicon:SetHeight(SkinPPHeight-fixscale(6))
				oldicon:SetWidth(SkinPPHeight-fixscale(6))
				
				oldicon:ClearAllPoints()
				-- Seal and RF icon
				if fname == "PallyPowerRF" then
					if tex == "IconSeal" then
						oldicon:SetPoint('LEFT', SkinPPHeight, 0)
					else
						oldicon:SetPoint('LEFT', fixscale(3), 0)
					end
				-- Aura icon and Auto icon
				elseif fname:find("(Au[rt][ao])$") then
					oldicon:SetPoint('LEFT', fixscale(3), 0)
				-- Player frames
				elseif fname:find("PowerC%d+P%d+$") then
					oldicon:SetPoint('TOPLEFT', fixscale(3), -fixscale(3))
				-- Class frames
				elseif fname:find("PowerC%d+$") then
					if tex == "ClassIcon" then
						oldicon:SetPoint('LEFT', fixscale(3), 0)
					else
						oldicon:SetPoint('LEFT', SkinPPHeight, 0)
					end
				else
					--oldicon:SetPoint('TOPLEFT', fixscale(3), -fixscale(3))
				end
				
				local panel = CreateFrame("Frame", fname..'New'..tex, frame)
				panel:SetAllPoints(oldicon)
				SetTemplate(panel)
				
				local icon = panel:CreateTexture()
				panel.icon = panel
				icon:SetPoint("TOPLEFT", panel, fixscale(2), -fixscale(2))
				icon:SetPoint("BOTTOMRIGHT", panel, -fixscale(2), fixscale(2))
				icon:SetTexCoord(.08, .92, .08, .92)
				icon:SetTexture(oldicon:GetTexture())
				--hacky tacky, yay!
				oldicon.SetTexture = function(tex,texstring)
					icon:SetTexture(texstring)
					--hide the border/bg if icon:SetTexture() is sued to hide the icon
					if not texstring then
						panel:SetAlpha(0)
					else
						panel:SetAlpha(1)
					end
				end
				oldicon.SetVertexColor = function(self, ...)
					--[[if r + b + g == 3 then
						icon:SetDesaturated(false)
					else
						icon:SetDesaturated(true)
					end]]
					icon:SetVertexColor(...)
				end
			end
		end			
	end
end

----------------------------------------------
-- update layout
----------------------------------------------

local _updatelayout = PallyPower.UpdateLayout
function PallyPower:UpdateLayout()
	self.opt.display.gapping = fixscale(4)
	self.opt.buffscale = ppmscale
--	self.opt.configscale = 0.8
	
	PallyPowerAnchor:SetFrameStrata("MEDIUM")
	PallyPowerAnchor:SetScale(0.75)
	self.opt.display.buttonHeight = SkinPPHeight
	self.opt.display.buttonWidth = SkinPPWidth
	
	_updatelayout(self)
	
	-- Update button layout for aura, rf and auto
	for _, button in pairs({PallyPowerAuto, PallyPowerRF, PallyPowerAura}) do
		local a, p, b, x, y = button:GetPoint()
		
		-- ridiculous, why is this a string and not an int
		local align = tonumber(self.opt.display.alignClassButtons)
		
		y = align < 4 and (y - fixscale(3)) or (y + fixscale(3))
	
		button:SetPoint(a,p,b,x,y)
	end
end
PallyPower:ApplySkin()
PallyPower:UpdateLayout()